searchData={"items":[{"type":"module","title":"Trading","doc":"Trading Infrastructure - A high-performance trading library focused on order book dynamics.\n\nThis library provides:\n- Efficient order book management\n- Order matching engine\n- Market data processing\n- Market microstructure analytics\n- Backtesting capabilities","ref":"Trading.html"},{"type":"function","title":"Trading.new_order/5","doc":"Creates a new order.","ref":"Trading.html#new_order/5"},{"type":"function","title":"Examples - Trading.new_order/5","doc":"iex> Trading.new_order(\"order1\", :buy, 150.00, 100, :limit)\n    %Trading.Order{id: \"order1\", side: :buy, ...}","ref":"Trading.html#new_order/5-examples"},{"type":"function","title":"Trading.new_order_book/1","doc":"Creates a new order book for a given symbol.","ref":"Trading.html#new_order_book/1"},{"type":"function","title":"Examples - Trading.new_order_book/1","doc":"iex> Trading.new_order_book(\"AAPL\")\n    %Trading.OrderBook{symbol: \"AAPL\", ...}","ref":"Trading.html#new_order_book/1-examples"},{"type":"module","title":"Trading.Analytics","doc":"Market microstructure analytics for analyzing order book dynamics.","ref":"Trading.Analytics.html"},{"type":"function","title":"Trading.Analytics.calculate_flow_toxicity/2","doc":"Analyzes order flow toxicity using various metrics.","ref":"Trading.Analytics.html#calculate_flow_toxicity/2"},{"type":"function","title":"Trading.Analytics.calculate_imbalance/1","doc":"Calculates order book imbalance.","ref":"Trading.Analytics.html#calculate_imbalance/1"},{"type":"function","title":"Trading.Analytics.calculate_metrics/2","doc":"Calculates comprehensive market microstructure metrics.","ref":"Trading.Analytics.html#calculate_metrics/2"},{"type":"function","title":"Trading.Analytics.calculate_mid_price/2","doc":"Calculates the mid price.","ref":"Trading.Analytics.html#calculate_mid_price/2"},{"type":"function","title":"Trading.Analytics.calculate_price_impact/3","doc":"Calculates price impact for a given order size.","ref":"Trading.Analytics.html#calculate_price_impact/3"},{"type":"function","title":"Trading.Analytics.calculate_spread/2","doc":"Calculates the bid-ask spread.","ref":"Trading.Analytics.html#calculate_spread/2"},{"type":"function","title":"Trading.Analytics.calculate_vwap/1","doc":"Calculates volume-weighted average price (VWAP) from trades.","ref":"Trading.Analytics.html#calculate_vwap/1"},{"type":"function","title":"Trading.Analytics.calculate_weighted_mid_price/1","doc":"Calculates the weighted mid price based on best bid/ask sizes.","ref":"Trading.Analytics.html#calculate_weighted_mid_price/1"},{"type":"module","title":"Trading.Analytics.TimeSeries","doc":"Time series analytics for market data and order book dynamics.","ref":"Trading.Analytics.TimeSeries.html"},{"type":"function","title":"Trading.Analytics.TimeSeries.autocorrelation/2","doc":"Calculates autocorrelation of returns.","ref":"Trading.Analytics.TimeSeries.html#autocorrelation/2"},{"type":"function","title":"Trading.Analytics.TimeSeries.calculate_volatility/2","doc":"Calculates volatility using various methods.","ref":"Trading.Analytics.TimeSeries.html#calculate_volatility/2"},{"type":"function","title":"Trading.Analytics.TimeSeries.detect_patterns/1","doc":"Detects microstructure patterns in order book data.","ref":"Trading.Analytics.TimeSeries.html#detect_patterns/1"},{"type":"function","title":"Trading.Analytics.TimeSeries.estimate_noise/2","doc":"Calculates market microstructure noise.","ref":"Trading.Analytics.TimeSeries.html#estimate_noise/2"},{"type":"function","title":"Trading.Analytics.TimeSeries.rolling_stats/3","doc":"Calculates rolling statistics over a time window.","ref":"Trading.Analytics.TimeSeries.html#rolling_stats/3"},{"type":"module","title":"Trading.Backtest.Engine","doc":"Event-driven backtesting engine with realistic order book simulation.","ref":"Trading.Backtest.Engine.html"},{"type":"function","title":"Trading.Backtest.Engine.add_strategy/3","doc":"Adds a strategy to the backtest.","ref":"Trading.Backtest.Engine.html#add_strategy/3"},{"type":"function","title":"Trading.Backtest.Engine.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Trading.Backtest.Engine.html#child_spec/1"},{"type":"function","title":"Trading.Backtest.Engine.load_historical_data/3","doc":"Loads historical data for backtesting.","ref":"Trading.Backtest.Engine.html#load_historical_data/3"},{"type":"function","title":"Trading.Backtest.Engine.run_backtest/2","doc":"Runs a backtest with the given configuration.","ref":"Trading.Backtest.Engine.html#run_backtest/2"},{"type":"function","title":"Trading.Backtest.Engine.start_link/1","doc":"Starts the backtesting engine.","ref":"Trading.Backtest.Engine.html#start_link/1"},{"type":"type","title":"Trading.Backtest.Engine.t/0","doc":"","ref":"Trading.Backtest.Engine.html#t:t/0"},{"type":"module","title":"Trading.Backtest.Event","doc":"Event structure for backtesting engine.","ref":"Trading.Backtest.Event.html"},{"type":"type","title":"Trading.Backtest.Event.event_type/0","doc":"","ref":"Trading.Backtest.Event.html#t:event_type/0"},{"type":"function","title":"Trading.Backtest.Event.new/3","doc":"Creates a new event.","ref":"Trading.Backtest.Event.html#new/3"},{"type":"type","title":"Trading.Backtest.Event.t/0","doc":"","ref":"Trading.Backtest.Event.html#t:t/0"},{"type":"module","title":"Trading.Backtest.Portfolio","doc":"Portfolio management for backtesting.","ref":"Trading.Backtest.Portfolio.html"},{"type":"function","title":"Trading.Backtest.Portfolio.available_capital/1","doc":"Gets available capital for trading.","ref":"Trading.Backtest.Portfolio.html#available_capital/1"},{"type":"function","title":"Trading.Backtest.Portfolio.get_position/2","doc":"Gets the current position for a symbol.","ref":"Trading.Backtest.Portfolio.html#get_position/2"},{"type":"function","title":"Trading.Backtest.Portfolio.get_trades/1","doc":"Gets all trades.","ref":"Trading.Backtest.Portfolio.html#get_trades/1"},{"type":"function","title":"Trading.Backtest.Portfolio.initial_capital/1","doc":"Gets initial capital.","ref":"Trading.Backtest.Portfolio.html#initial_capital/1"},{"type":"function","title":"Trading.Backtest.Portfolio.new/1","doc":"Creates a new portfolio.","ref":"Trading.Backtest.Portfolio.html#new/1"},{"type":"type","title":"Trading.Backtest.Portfolio.position/0","doc":"","ref":"Trading.Backtest.Portfolio.html#t:position/0"},{"type":"function","title":"Trading.Backtest.Portfolio.record_equity/2","doc":"Records equity curve point.","ref":"Trading.Backtest.Portfolio.html#record_equity/2"},{"type":"type","title":"Trading.Backtest.Portfolio.t/0","doc":"","ref":"Trading.Backtest.Portfolio.html#t:t/0"},{"type":"function","title":"Trading.Backtest.Portfolio.total_value/1","doc":"Calculates total portfolio value.","ref":"Trading.Backtest.Portfolio.html#total_value/1"},{"type":"type","title":"Trading.Backtest.Portfolio.trade/0","doc":"","ref":"Trading.Backtest.Portfolio.html#t:trade/0"},{"type":"function","title":"Trading.Backtest.Portfolio.update_market_values/2","doc":"Updates market values of positions.","ref":"Trading.Backtest.Portfolio.html#update_market_values/2"},{"type":"function","title":"Trading.Backtest.Portfolio.update_position/5","doc":"Updates a position based on a fill.","ref":"Trading.Backtest.Portfolio.html#update_position/5"},{"type":"behaviour","title":"Trading.Backtest.Strategy","doc":"Base behaviour for trading strategies.","ref":"Trading.Backtest.Strategy.html"},{"type":"callback","title":"Trading.Backtest.Strategy.init/1","doc":"","ref":"Trading.Backtest.Strategy.html#c:init/1"},{"type":"function","title":"Trading.Backtest.Strategy.new/2","doc":"Creates a new strategy instance.","ref":"Trading.Backtest.Strategy.html#new/2"},{"type":"function","title":"Trading.Backtest.Strategy.on_fill/2","doc":"Processes fill notifications.","ref":"Trading.Backtest.Strategy.html#on_fill/2"},{"type":"callback","title":"Trading.Backtest.Strategy.on_fill/2","doc":"","ref":"Trading.Backtest.Strategy.html#c:on_fill/2"},{"type":"function","title":"Trading.Backtest.Strategy.on_market_data/4","doc":"Processes market data and generates signals.","ref":"Trading.Backtest.Strategy.html#on_market_data/4"},{"type":"callback","title":"Trading.Backtest.Strategy.on_market_data/4","doc":"","ref":"Trading.Backtest.Strategy.html#c:on_market_data/4"},{"type":"type","title":"Trading.Backtest.Strategy.signal/0","doc":"","ref":"Trading.Backtest.Strategy.html#t:signal/0"},{"type":"type","title":"Trading.Backtest.Strategy.t/0","doc":"","ref":"Trading.Backtest.Strategy.html#t:t/0"},{"type":"module","title":"Trading.MarketData.Feed","doc":"Market data feed handler for processing real-time market data updates.","ref":"Trading.MarketData.Feed.html"},{"type":"function","title":"Trading.MarketData.Feed.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Trading.MarketData.Feed.html#child_spec/1"},{"type":"function","title":"Trading.MarketData.Feed.get_order_book/2","doc":"Gets the current state of an order book.","ref":"Trading.MarketData.Feed.html#get_order_book/2"},{"type":"type","title":"Trading.MarketData.Feed.market_data_type/0","doc":"","ref":"Trading.MarketData.Feed.html#t:market_data_type/0"},{"type":"function","title":"Trading.MarketData.Feed.process_update/2","doc":"Processes a market data update.","ref":"Trading.MarketData.Feed.html#process_update/2"},{"type":"function","title":"Trading.MarketData.Feed.start_link/1","doc":"Starts a market data feed.","ref":"Trading.MarketData.Feed.html#start_link/1"},{"type":"function","title":"Trading.MarketData.Feed.subscribe/3","doc":"Subscribes to market data updates.","ref":"Trading.MarketData.Feed.html#subscribe/3"},{"type":"type","title":"Trading.MarketData.Feed.subscriber/0","doc":"","ref":"Trading.MarketData.Feed.html#t:subscriber/0"},{"type":"type","title":"Trading.MarketData.Feed.t/0","doc":"","ref":"Trading.MarketData.Feed.html#t:t/0"},{"type":"function","title":"Trading.MarketData.Feed.unsubscribe/2","doc":"Unsubscribes from market data updates.","ref":"Trading.MarketData.Feed.html#unsubscribe/2"},{"type":"module","title":"Trading.MarketData.Parser","doc":"Parses market data from various feed formats.","ref":"Trading.MarketData.Parser.html"},{"type":"function","title":"Trading.MarketData.Parser.parse_binary/1","doc":"Parses binary market data (for low-latency feeds).","ref":"Trading.MarketData.Parser.html#parse_binary/1"},{"type":"function","title":"Trading.MarketData.Parser.parse_csv_line/2","doc":"Parses CSV market data (for historical data).","ref":"Trading.MarketData.Parser.html#parse_csv_line/2"},{"type":"function","title":"Trading.MarketData.Parser.parse_fix/1","doc":"Parses a FIX message into market data.","ref":"Trading.MarketData.Parser.html#parse_fix/1"},{"type":"function","title":"Trading.MarketData.Parser.parse_json/1","doc":"Parses JSON market data.","ref":"Trading.MarketData.Parser.html#parse_json/1"},{"type":"module","title":"Trading.MatchingEngine","doc":"Order matching engine that handles order execution with price-time priority.","ref":"Trading.MatchingEngine.html"},{"type":"function","title":"Trading.MatchingEngine.add_symbol/2","doc":"Adds a new symbol to the matching engine.","ref":"Trading.MatchingEngine.html#add_symbol/2"},{"type":"function","title":"Trading.MatchingEngine.cancel_order/3","doc":"Cancels an order.","ref":"Trading.MatchingEngine.html#cancel_order/3"},{"type":"function","title":"Trading.MatchingEngine.get_market_data/2","doc":"Gets market data for a symbol.","ref":"Trading.MatchingEngine.html#get_market_data/2"},{"type":"function","title":"Trading.MatchingEngine.get_order_book/2","doc":"Gets the order book for a symbol.","ref":"Trading.MatchingEngine.html#get_order_book/2"},{"type":"function","title":"Trading.MatchingEngine.new/0","doc":"Creates a new matching engine.","ref":"Trading.MatchingEngine.html#new/0"},{"type":"function","title":"Trading.MatchingEngine.register_callback/3","doc":"Registers a callback for events.","ref":"Trading.MatchingEngine.html#register_callback/3"},{"type":"function","title":"Trading.MatchingEngine.submit_order/2","doc":"Submits an order to the matching engine.","ref":"Trading.MatchingEngine.html#submit_order/2"},{"type":"type","title":"Trading.MatchingEngine.t/0","doc":"","ref":"Trading.MatchingEngine.html#t:t/0"},{"type":"type","title":"Trading.MatchingEngine.trade/0","doc":"","ref":"Trading.MatchingEngine.html#t:trade/0"},{"type":"module","title":"Trading.Order","doc":"Represents a trading order with various types and attributes.","ref":"Trading.Order.html"},{"type":"function","title":"Trading.Order.active?/1","doc":"Checks if an order is active.","ref":"Trading.Order.html#active?/1"},{"type":"function","title":"Trading.Order.executable_at_price?/2","doc":"Checks if an order can be executed at a given price.","ref":"Trading.Order.html#executable_at_price?/2"},{"type":"function","title":"Trading.Order.fill/2","doc":"Fills an order partially or completely.","ref":"Trading.Order.html#fill/2"},{"type":"function","title":"Trading.Order.iceberg_order/6","doc":"Creates an iceberg order.","ref":"Trading.Order.html#iceberg_order/6"},{"type":"function","title":"Trading.Order.limit_order/5","doc":"Creates a limit order.","ref":"Trading.Order.html#limit_order/5"},{"type":"function","title":"Trading.Order.market_order/4","doc":"Creates a market order.","ref":"Trading.Order.html#market_order/4"},{"type":"function","title":"Trading.Order.new/6","doc":"Creates a new order with the given parameters.","ref":"Trading.Order.html#new/6"},{"type":"type","title":"Trading.Order.order_type/0","doc":"","ref":"Trading.Order.html#t:order_type/0"},{"type":"type","title":"Trading.Order.side/0","doc":"","ref":"Trading.Order.html#t:side/0"},{"type":"type","title":"Trading.Order.status/0","doc":"","ref":"Trading.Order.html#t:status/0"},{"type":"function","title":"Trading.Order.stop_order/5","doc":"Creates a stop order.","ref":"Trading.Order.html#stop_order/5"},{"type":"type","title":"Trading.Order.t/0","doc":"","ref":"Trading.Order.html#t:t/0"},{"type":"type","title":"Trading.Order.time_in_force/0","doc":"","ref":"Trading.Order.html#t:time_in_force/0"},{"type":"function","title":"Trading.Order.update_status/2","doc":"Updates order status.","ref":"Trading.Order.html#update_status/2"},{"type":"function","title":"Trading.Order.validate/1","doc":"Validates an order.","ref":"Trading.Order.html#validate/1"},{"type":"module","title":"Trading.OrderBook","doc":"Efficient limit order book implementation using ETS for O(log n) operations.\n\nThe order book maintains buy and sell sides with price-time priority.","ref":"Trading.OrderBook.html"},{"type":"function","title":"Trading.OrderBook.add_order/2","doc":"Adds an order to the order book.","ref":"Trading.OrderBook.html#add_order/2"},{"type":"function","title":"Trading.OrderBook.best_bid_ask/1","doc":"Gets the best bid and ask prices.","ref":"Trading.OrderBook.html#best_bid_ask/1"},{"type":"function","title":"Trading.OrderBook.cancel_order/2","doc":"Cancels an order in the order book.","ref":"Trading.OrderBook.html#cancel_order/2"},{"type":"function","title":"Trading.OrderBook.get_depth/2","doc":"Gets the order book depth up to a certain level.","ref":"Trading.OrderBook.html#get_depth/2"},{"type":"function","title":"Trading.OrderBook.get_orders_at_price/3","doc":"Gets all orders at a specific price level.","ref":"Trading.OrderBook.html#get_orders_at_price/3"},{"type":"function","title":"Trading.OrderBook.get_stats/1","doc":"Gets market depth statistics.","ref":"Trading.OrderBook.html#get_stats/1"},{"type":"function","title":"Trading.OrderBook.get_volume_at_price/3","doc":"Gets total volume at a specific price level.","ref":"Trading.OrderBook.html#get_volume_at_price/3"},{"type":"function","title":"Trading.OrderBook.new/1","doc":"Creates a new order book for a given symbol.","ref":"Trading.OrderBook.html#new/1"},{"type":"function","title":"Trading.OrderBook.order_count/1","doc":"Gets the total number of orders in the book.","ref":"Trading.OrderBook.html#order_count/1"},{"type":"type","title":"Trading.OrderBook.t/0","doc":"","ref":"Trading.OrderBook.html#t:t/0"},{"type":"module","title":"Trading.OrderBook.PriceLevel","doc":"Represents a price level in the order book with efficient order management.","ref":"Trading.OrderBook.PriceLevel.html"},{"type":"function","title":"Trading.OrderBook.PriceLevel.add_order/2","doc":"Adds an order to the price level.","ref":"Trading.OrderBook.PriceLevel.html#add_order/2"},{"type":"function","title":"Trading.OrderBook.PriceLevel.empty?/1","doc":"Checks if the price level is empty.","ref":"Trading.OrderBook.PriceLevel.html#empty?/1"},{"type":"function","title":"Trading.OrderBook.PriceLevel.new/2","doc":"Creates a new price level.","ref":"Trading.OrderBook.PriceLevel.html#new/2"},{"type":"function","title":"Trading.OrderBook.PriceLevel.peek_first/1","doc":"Gets the first order in the level (price-time priority).","ref":"Trading.OrderBook.PriceLevel.html#peek_first/1"},{"type":"function","title":"Trading.OrderBook.PriceLevel.pop_first/1","doc":"Removes and returns the first order.","ref":"Trading.OrderBook.PriceLevel.html#pop_first/1"},{"type":"function","title":"Trading.OrderBook.PriceLevel.remove_order/2","doc":"Removes an order from the price level.","ref":"Trading.OrderBook.PriceLevel.html#remove_order/2"},{"type":"type","title":"Trading.OrderBook.PriceLevel.t/0","doc":"","ref":"Trading.OrderBook.PriceLevel.html#t:t/0"},{"type":"function","title":"Trading.OrderBook.PriceLevel.to_list/1","doc":"Converts the price level to a list of orders.","ref":"Trading.OrderBook.PriceLevel.html#to_list/1"},{"type":"function","title":"Trading.OrderBook.PriceLevel.update_order/3","doc":"Updates an order in the price level.","ref":"Trading.OrderBook.PriceLevel.html#update_order/3"},{"type":"module","title":"Trading.Strategies.Momentum","doc":"Example momentum trading strategy.","ref":"Trading.Strategies.Momentum.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}